SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'JuanEdi 4/29/2013 19:28'!
blueGhost

	^ Ghost new! !

!PacManTest methodsFor: 'actors' stamp: 'JuanEdi 4/29/2013 19:43'!
blueberry

	^ Fruit new! !

!PacManTest methodsFor: 'movements' stamp: 'JuanEdi 4/29/2013 21:02'!
down

	^ 0@(-1)! !

!PacManTest methodsFor: 'construction block types' stamp: 'JuanEdi 4/29/2013 20:10'!
ghostHouseDoorType

	^ GhostHouseDoorType new! !

!PacManTest methodsFor: 'movements' stamp: 'JuanEdi 4/29/2013 21:02'!
left

	^ -1@0! !

!PacManTest methodsFor: 'construction block types' stamp: 'JuanEdi 4/29/2013 20:43'!
leftTransporterType

	^ TransporterType new! !

!PacManTest methodsFor: 'actors' stamp: 'JuanEdi 4/29/2013 19:41'!
pacman

	^ Pacman new! !

!PacManTest methodsFor: 'movements' stamp: 'JuanEdi 4/29/2013 21:03'!
right

	^ 1@0! !

!PacManTest methodsFor: 'construction block types' stamp: 'JuanEdi 4/29/2013 19:44'!
spaceType

	^ SpaceType new! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'JuanEdi 4/29/2013 21:03'!
up

	^ 0@1! !

!PacManTest methodsFor: 'construction block types' stamp: 'JuanEdi 4/29/2013 19:33'!
wallType

	^ WallType new! !

Object subclass: #Actor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Actor methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 21:26'!
nextPositionMovingInto: aCellType going: aDirection 
	
	self subclassResponsibility ! !

Actor subclass: #Fruit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Fruit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 21:27'!
nextPositionMovingInto: aCellType going: aDirection 
	
	^ aCellType nextPositionForFruit: self going: aDirection! !

!Fruit methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 19:43'!
position
	^ 0@0! !

Actor subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 21:27'!
nextPositionMovingInto: aCellType going: aDirection 
	
	^ aCellType nextPositionForGhost: self going: aDirection! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 19:29'!
position
	^ 0@0.! !

Actor subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 21:27'!
nextPositionMovingInto: aCellType going: aDirection 
	
	^ aCellType nextPositionForPacman: self going: aDirection! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 19:42'!
position
	^ 0@0! !

Object subclass: #CellType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!CellType methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 21:00'!
nextPositionFor: anActor going: aDirection 
	
	self subclassResponsibility ! !

CellType subclass: #GhostHouseDoorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 21:17'!
nextPositionFor: anActor going: aDirection 
	
	^ anActor nextPositionMovingInto: self going: aDirection! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 21:05'!
nextPositionForFruit: aFruit going: aDirection 
	
	^ aFruit position + aDirection.! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 21:04'!
nextPositionForGhost: aGhost going: aDirection 
	
	^ aGhost position + aDirection.! !

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 20:40'!
nextPositionForPacman: aPacman going: aLeft 
	
	^ aPacman position! !

CellType subclass: #SpaceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceType methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 21:04'!
nextPositionFor: anActor going: aDirection

	^ anActor position + aDirection.! !

CellType subclass: #TransporterType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!TransporterType methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 21:17'!
nextPositionFor: anActor going: aDirection 
	
	^ anActor nextPositionMovingInto: self going: aDirection! !

!TransporterType methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 20:51'!
nextPositionForFruit: aFruit going: aLeft 
	
	^ 5@10! !

!TransporterType methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 20:49'!
nextPositionForGhost: aGhost going: aDirection 
	
	^ aGhost position! !

!TransporterType methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 20:51'!
nextPositionForPacman: aPacman going: aDirection 
	
	^ 3@10! !

CellType subclass: #WallType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallType methodsFor: 'as yet unclassified' stamp: 'JuanEdi 4/29/2013 20:16'!
nextPositionFor: anActor going: aDirection 
	
	^ anActor position ! !
